%
% Tags used in this file:
%
%     INCONSISTENCY -- discrepancy between our dfn and FIR definition
%     DROPPED -- FIR feature that has been dropped from our specification
%     ERROR -- outright mistake between FIR and our specification
%

\sectionA{The \fir{} Syntax}
\label{section:syntax}

\iftechreport

   The figures below define the syntactically valid terms of the \fir.
   Each term is accompanied by a brief description, and in most cases,
   the corresponding \fir{} ``entity'', an \ocaml{} expression or type
   used to implement that term\footnote{These are mainly for the benefit
   of the authors and we omit any discussion of these implementation
   details from the paper. $\hint$ is used in these entities to mark an
   expression that is used only as a hint for debugging purposes or
   optimization, but has no effect on the computation.}.  The precise meanings
   of these terms are given by the typing rules
   (Chapter~\ref{section:typing-rules}) and operational semantics
   (Chapter~\ref{section:op-semantics}).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Basic syntax and notation
%

   \sectionB{Basic syntax and notation}

\fi

In the syntax descriptions below, we use the following conventions.  In
general, we use the meta-variables $i$, $j$, and $k$ to refer to arbitrary
integers, and the meta-variables $m$ and $n$ to refer to arbitrary nonnegative
integers.  In most cases, we use the meta-variable $m$ to enumerate type
parameters $\cvec{\alpha\subi}{\polybase}{\polybound}$, and the meta-variable
$n$ to enumerate actual parameters $\cvec{v\subi}{\varbase}{\varbound}$.
\if\polybasezero\polybase
   % no text in this case
\else
   The runtime values are indexed from zero; in cases where this matters,
   we enumerate type parameters with
   $\cvec{\alpha\subi}{\polybasezero}{\polyboundzero}$
   and actual parameters with
   $\cvec{v\subi}{\varbasezero}{\varboundzero}$.
\fi

The meta-variable $v$ refers to program variables.  The meta-variable
$\xlabel$ refers to program \emph{labels}, which are used as record
field tags and names for global variables.  The labels and variables are
distinct sets.

The meta-variables $t$ and $u$ refer to program types, while the Greek
letters $\alpha, \beta, \gamma$ and the meta-variable
$\tyvar$ refer to type variables.

We use the notation $\lvec{v\subi}{\varbase}{\varbound}$ to denote the vector
$\cvec{v\subi}{\varbase}{\varbound}$.  The index variable is implicitly
$\xxxdefaultindex$.  An alternate notation
${\setindex{j} \lvec{v\subi}{\varbase}{\varbound}}$ explicitly uses a
different index variable $j$.

The basic program syntax is shown in Figure~\ref{figure:fir-entities}.
There are several forms of numbers.  In addition to the integers $i$,
there are raw integers with various bit precisions (8, 16, 32, and
64) and signedness interpretations (signed and unsigned).  The
floating-point values also have several precisions (32, 64, and 80 bits).
The meta-variable $x$ stands for a floating-point value.

Sets of integers are used in integer ``pattern matching'' expressions.  The
sets are represented by lists of closed intervals $[i_1, i_2]$.  In the case
of raw integer sets, the end points of each interval can have any of the
several bit precisions.  We also commonly represent a singleton set containing
the integer $i$ using the notation $\{ i \}$.

There are two kinds of tuples, \emph{normal} tuples and \emph{box} tuples.
The box tuples always have arity one, and are used to pass
arbitrary values (such as large precision integers, or floating-point
values) as polymorphic values.

\makefigure{figure:fir-entities}{Basic FIR terms}{
$$
\begin{array}{\iftechreport rclll \else rcll@{}l \fi}
\multicolumn{3}{c}{\hbox{Entity}}
         & \hbox{Description}
         & \tronly{\hbox{FIR Entity}}\\
\hline

         &     & v_1, v_2, \ldots
               & \hbox{Variable names}
               & \tronly{\mt{Fir.var}} \\

         &     & \tyvar_1, \tyvar_2, \ldots\\
         &     & \alpha, \beta, \ldots
               & \hbox{Type variables}
               & \tronly{\mt{Fir.ty\_var}}\\

         &     & \xlabel_1, \xlabel_2, \ldots
               & \hbox{Labels}
               & \tronly{\mt{Fir.label}} \\

i        & ::= & \ldots \vbar -1 \vbar 0 \vbar 1 \vbar \ldots
               & \hbox{Integer constants}
               & \tronly{\mt{int}}\\

\\

\pre     & ::= & 8 \vbar 16 \vbar 32 \vbar 64
               & \hbox{Integer precisions}
               & \tronly{\mt{Int8} \vbar \mt{Int16} \vbar \mt{Int32} \vbar \mt{Int64}}\\
\sign    & ::= & \signed \vbar \unsigned
               & \hbox{Integer signedness}
               & \tronly{\mt{true} \vbar \mt{false}} \\
\rawint  & ::= & (i, \pre, \sign)
               & \iftechreport \hbox{Raw integer constants} \else \hbox{Rawint constants} \fi
               & \tronly{\mt{Rawint.rawint}} \\

\\

\fpre    & ::= & 32 \vbar 64 \vbar 80
               & \iftechreport \hbox{Floating-point precisions} \else \hbox{Float precisions} \fi
               & \tronly{\mt{Single} \vbar \mt{Double} \vbar \mt{LongDouble}} \\
x        & ::= & \zfloat
               & \iftechreport \hbox{Floating-point constants} \else \hbox{Float constants} \fi
               & \tronly{\mt{Rawfloat.rawfloat}} \\

\\

\intset     & ::= & [i_1^1, i_2^1], \ldots, [i_1^n, i_2^n]
                  & \hbox{Integer interval set}
                  & \tronly{\mt{IntSet.t}} \\
\rawintset  & ::= & [\rawint_1^1, \rawint_2^1], \ldots, [\rawint_1^n, \rawint_2^n]
                  & \iftechreport \hbox{Raw integer interval set} \else \hbox{Rawint set} \fi
                  & \tronly{\mt{RawIntSet.t}} \\
\xset       & ::= & \intset \vbar \rawintset
                  & \hbox{Arbitrary sets}
                  & \tronly{\mt{IntSet}\ \intset \vbar \mt{RawIntSet}\ \rawintset} \\

\\

\tupleclass & ::= & \normaltuple \vbar \boxedtuple
                  & \hbox{Tuple classes}
                  & \tronly{\mt{NormalTuple} \vbar \mt{BoxTuple}} \\

% DROPPED:
%     subop -- redundant information, can be computed based on
%        known information.

\end{array}
$$
}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% FIR type system
%

\sectionB{FIR type system}

The \fir{} has two classes of types, the basic types, shown in
Figure~\ref{figure:fir-types}, and the type definitions, shown in
Figure~\ref{figure:fir-type-defs}.
\iftechreport
   The types are described more fully in Chapter~\ref{section:typing-rules},
   which defines the program typing rules.
\fi

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Basic types
%

\sectionC{Basic types}

\begin{itemcase}{Numbers}
   \iftechreport
      The notation $\tyint$ refers to a 31-bit signed integer value.  The runtime 
      can always distinguish $\tyint$ values from pointers\footnote{To distinguish
      integers from pointers, the runtime often represents the 31-bit quantity $i$ as a 32-bit value $2i + 1$;
      pointers always have have a least-significant-bit of $0$.}.
   \else
      The type $\tyint$ refers to 31-bit, signed integers.
   \fi
   %
   The type $\tyenum{i}$ includes the integers $\mkset{0, \ldots, i - 1}$.
   \iftechreport
      The maximum enumeration value is bounded by the value $\maxenum$\footnote{This
      is explained further in a footnote in Section~\ref{section:type-equality}.}.
   \fi
   The type $\tyenum{0}$ is valid and represents the void type.
   %
   The native integer type $\tyrawint{\pre}{\sign}$ includes values of a
   specified bit precision and signedness interpretation.
   %
   The type $\tyfloat{\fpre}$ includes floating-point values of a specified bit
   precision.
\end{itemcase}

\begin{itemcase}{Tuples}
   The tuple type
   $\tytuple{\tupleclass}{\cvec{\typename\subi}{\varbase}{\varbound}}$ represents
   a tuple $\storetuple{\cvec{v\subi}{\varbase}{\varbound}}$, where each value
   $v_i$ has type $t_i$.
\end{itemcase}

\begin{itemcase}{Arrays}
   Arrays resemble tuples, but the elements of an array all have the same type,
   and an array has arbitrary nonnegative dimension.
\end{itemcase}

\begin{itemcase}{Unions}
   The union type $\tyunion{\tyvar}{\cvec{u\subi}{\polybase}{\polybound}}{\intset}$
   represents values in a polymorphic union type, which is defined as
   $\tyvar = \tydefunion{\cvec{\alpha\subi}{\polybase}{\polybound}}{\plusvec{\vec{t}\subi}{\varbase}{\varbound}}$
   (type definitions are discussed below).  A value of type
   $\tyunion{\tyvar}{\cvec{u\subi}{\polybase}{\polybound}}{\{ j \}}$ has type
   $\vec{t}_j[\cvec{u\subi/\alpha\subi}{\polybase}{\polybound}]$\footnote{By
   $\tau[t/\alpha]$ we mean non-capturing substitution of $t$ for $\alpha$ in a
   term $\tau$. See Section~\ref{section:type-subst}.}.
\end{itemcase}

\begin{itemcase}{Unsafe data areas}
   The unsafe
   \iftechreport
      types $\tyrawdata$ and $\tyframe{\tyvar}{\cvec{\typename\subi}{\polybase}{\polybound}}$ represent
   \else
      type $\tyrawdata$ represents
   \fi
   arbitrary data.  Values of type $\tyrawdata$ are normally used to represent
   data aggregates for imperative programming languages, like C, that allow the
   assignment of values to the data area without regard for the data type.  Data
   areas with the $\tyrawdata$ type have no explicit substructure%
   \iftechreport
      , while values with the
      $\tyframe{\tyvar}{\cvec{\typename\subi}{\polybase}{\polybound}}$
      type are defined as unsafe records, where the fields in the
      record are not strongly typed.
   \else
      .
   \fi
\end{itemcase}

\begin{itemcase}{Functions}
   The function type $\tyfun{(\cvec{\typename\subi}{\varbase}{\varbound})}{t}$
   includes the functions that return a value of type $t$, given arguments of
   types $\cvec{t\subi}{\varbase}{\varbound}$.
\end{itemcase}

\tronly{
   \begin{itemcase}{Polymorphic type variables}
      The variables $\alpha, \beta, \ldots$ refer to type variables and
      parameters, used in the polymorphic types below.
   \end{itemcase}
}

\begin{itemcase}{Type application}
   The type $\tyapply{\tyvar}{\cvec{\typename\subi}{\polybase}{\polybound}}$
   applies arguments to a type function, defined as part of a program context
   \iftechreport
      (see Chapter~\ref{section:judgments}).
   \else
      (see Section~\ref{section:judgments}).
   \fi
   If the definition is a parameterized
   type $\Lambda{\cvec{\alpha\subi}{\polybase}{\polybound}}. t$, the type
   $\tyapply{\tyvar}{\cvec{\typename\subi}{\polybase}{\polybound}}$ is defined as
   the type $t[\cvec{t\subi/\alpha\subi}{\polybase}{\polybound}]$.  For example,
   in a context containing the definition
   $\gamma = \Lambda{\alpha, \beta}.{\tytuple{\normaltuple}{\alpha, \beta}}$, the type
   $\tyapply{\gamma}{\tyint, \tyenum{2}}$ is the same as the type
   $\tytuple{\normaltuple}{\tyint, \tyenum{2}}$.
\end{itemcase}

\begin{itemcase}{Universal types}
   The universal type $\tyall{\cvec{\alpha\subi}{\polybase}{\polybound}}{t}$
   defines a polymorphic type, where $t$ must be a function type (see Section~\ref{section:type-equality}).

   \nocomment{JDS:  We need to comment on \emph{why} the embedded type $t$ must be a function.
            Why do we disallow tuples, f.e.?  I might try to comment on this, but I need to
            rethink it through since I don't have a very clear understanding of it...}
\end{itemcase}

\begin{itemcase}{Existential types}
   The existential type $\tyexists{\cvec{\alpha\subi}{\polybase}{\polybound}}{t}$
   defines a type abstraction.  The values in an existential type have the form
   $\atomtypack{\tyexists{\cvec{\alpha\subi}{\polybase}{\polybound}}{t}}{v}{\cvec{\typename\subi}{\polybase}{\polybound}}$,
   where $v$ has type
   $t[\cvec{t\subi/\alpha\subi}{\polybase}{\polybound}]$.
\end{itemcase}

\begin{itemcase}{Projections}
   The type projection $\typroject{v}{i}$ is used for values having existential type
   $\tyexists{\cvec{\alpha\subi}{\polybasezero}{\polyboundzero}}{t}$.
   If a value $v = \atomtypack{\tyexists{\cvec{\alpha\subi}{\polybasezero}{\polyboundzero}}{t}}
                              {v'}{\cvec{t\subi}{\polybasezero}{\polyboundzero}}$
   has type $\tyexists{\cvec{\alpha\subi}{\polybasezero}{\polyboundzero}}{t}$,
   then $\typroject{v}{i}$ is equivalent to $t_i$.
\end{itemcase}

\makefigure{figure:fir-types}{The FIR type system}{
$$
\begin{array}{\iftechreport rclll \else rcll@{}l \fi}
& & \hbox{Type} & \hbox{Description} & \tronly{\hbox{FIR Type}}\\
\hline

t & ::= & \tyint
        & \hbox{Boxed integers}
        & \tronly{\mt{TyInt}} \\
  &  |  & \tyenum{i}
        & \hbox{Integer enumerations}
        & \tronly{\mt{TyEnum}\ i} \\
  &  |  & \tyrawint{\pre}{\sign}
        & \hbox{Native integers}
        & \tronly{\mt{TyRawInt}\ (\pre, \sign)} \\
  &  |  & \tyfloat{\fpre}
        & \hbox{Floating-point values}
        & \tronly{\mt{TyFloat}\ \fpre} \\

\\

  &  |  & \tytuple{\tupleclass}{\cvec{\typename\subi}{\polybase}{\polybound}}
        & \hbox{Tuple type}
        & \tronly{\mt{TyTuple}\ (\tupleclass, [\semivec{\typename\subi}{\polybase}{\polybound}])} \\
  &  |  & \tyarray{t}
        & \hbox{Array type}
        & \tronly{\mt{TyArray}\ t} \\
  &  |  & \tyunion{\tyvar}{\cvec{\typename\subi}{\polybase}{\polybound}}{\intset}
        & \hbox{Constructor type}
        & \tronly{\mt{TyUnion}\ (\tyvar, [\semivec{\typename\subi}{\polybase}{\polybound}], \intset)} \\

\\

  &  |  & \tyrawdata
        & \hbox{Unsafe data}
        & \tronly{\mt{TyRawData}} \\

\iftechreport
  &  |  & \tyframe{\tyvar}{\cvec{\typename\subi}{\polybase}{\polybound}}
        & \hbox{Frame record}
        & \tronly{\mt{TyFrame}\ (\tyvar, [\semivec{\typename\subi}{\polybase}{\polybound}])} \\
\\
\fi

  &  |  & \tyfun{(\cvec{\typename\subi}{\polybase}{\polybound})}{t}
        & \hbox{Function type}
        & \tronly{\mt{TyFun}\ ([\semivec{\typename\subi}{\polybase}{\polybound}], t)}\\

% DROPPED:
%     TyPointer omitted -- optimization only

\\

  &  |  & \alpha, \beta, \ldots
        & \hbox{Polymorphic type vars}
        & \tronly{\mt{TyVar}\ \alpha, \mt{TyVar}\ \beta, \ldots}\\
  &  |  & \tyapply{\tyvar}{\cvec{\typename\subi}{\polybase}{\polybound}}
        & \hbox{Type application}
        & \tronly{\mt{TyApply}\ (\tyvar, [\semivec{\typename\subi}{\polybase}{\polybound}])}\\
  &  |  & \tyall{\cvec{\alpha\subi}{\polybase}{\polybound}}{t}
        & \hbox{Universal types}
        & \tronly{\mt{TyAll}\ ([\semivec{\alpha\subi}{\polybase}{\polybound}], t)}\\
  &  |  & \tyexists{\cvec{\alpha\subi}{\polybase}{\polybound}}{t}
        & \hbox{Existential types}
        & \tronly{\mt{TyExists}\ ([\semivec{\alpha\subi}{\polybase}{\polybound}], t)}\\
  &  |  & \typroject{v}{i}
        & \hbox{Abstract type}
        & \tronly{\mt{TyProject}\ (v, i)}
\end{array}
$$
}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Type definitions
%

\sectionC{Type definitions}
\label{section:type-definitions}

Type definitions define parameterized
\iftechreport
   types, unions and frame records.
\else
   types and unions.
\fi
A type definition $\tydef$ has the form
$\tydeflambda{\cvec{\alpha\subi}{\polybase}{\polybound}}{\stydef}$, where
$\stydef$ is a simple type definition abstracted over type parameters
$\cvec{\alpha\subi}{\polybase}{\polybound}$.

A simple type definition can be a
\iftechreport
   type, a disjoint union, or a frame record type.
\else
   type or a disjoint union.
\fi
%
Disjoint unions are defined on type vectors
$\plusvec{\vec{t}\subi}{\polybase}{\polybound}$.  Each type vector $\vec{t}_i$
is effectively a tuple space $\xvector{\cvec{t\subi}{\varbase}{\varbound}}$.
The translation of ML datatypes is straightforward.  For example, an ML
datatype for labeled binary trees might be declared as follows.
%
$$
\begin{minipage}{3in}
\begin{verbatim}
type 'a tree =
   Leaf
 | Node of 'a tree * 'a * 'a tree
\end{verbatim}
\end{minipage}
$$
%
The FIR representation eliminates the constructor names, and forms
a disjoint union of tuples.
%
$$
\ms{tree} = \tydeflambda{\alpha}{\xvector{}
    + \xvector{\tyapply{\ms{tree}}{\alpha},
               \alpha,
               \tyapply{\ms{tree}}{\alpha}}}
$$

\iftechreport
   Frame records are used for representing procedure frames for
   a language like C.  A frame is a doubly-nested record, where the
   primary field corresponds to each procedure variable in the frame, and
   the sub-record describes the variable's parts (for example, pointer
   variables have two parts: a base pointer that points to the base
   of the data area, and an integer offset into the data area).
\fi

\makefigure{figure:fir-type-defs}{FIR type definitions}{
$$
\begin{array}{rcll}
& & \hbox{Type} & \hbox{Description}\\
\hline

\vec{t}     & ::= & \xvector{\cvec{t\subi}{\varbase}{\varbound}}
                  & \hbox{List of types}\\
\iftechreport
\tyrecordname & ::= & \tyrecord{\cvec{\framelabel{sf}\subi : t\subi}{\polybase}{\polybound}}
                  & \hbox{Record type}\\
\\
\fi

\stydef     & ::= & t
                  & \hbox{Type abstraction}\\
            & |   & \plusvec{\vec{t}\subi}{\polybase}{\polybound}
                  & \hbox{Union type}\\
\iftechreport
            & |   & \tyframerecord{\cvec{\framelabel{f}\subi : \tyrecordname\subi}{\varbase}{\varbound}}
                  & \hbox{Frame type}\\
\fi
\tydef      & ::= & \tydeflambda{\cvec{\alpha\subi}{\polybase}{\polybound}}{\stydef}
                  & \hbox{Polymorphic type}
\end{array}
$$
}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% FIR expressions
%

\sectionB{FIR expressions}

Expressions in the \fir{} are divided into two classes: the
atoms $a$, and general expressions $e$.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Atoms
%

\sectionC{Atoms}

The atoms $a$ represent values, including numbers, variables, and basic
arithmetic.  They are listed in Figure~\ref{figure:fir-atoms}.  Atoms are
functional: apart from arithmetic exceptions\footnote{A notable arithmetic
exception is division by zero.}, the order of atom evaluation does not matter.
The atoms include the following.

\begin{itemcase}{Numbers} \iftechreport \ \fi
   \begin{itemize}
   \setlength\itemsep{0in}
   \item The integers $\atomint{i}$ have type $\tyint$.
   \item The enumeration values $\atomenum{i_\ms{bound}}{i_\ms{value}}$
         represent constant values in type $\tyenum{i_\ms{bound}}$.  For the
         atom to be well-formed, $0 \le i_\ms{value} < i_\ms{bound}$ must hold.
   \item The raw integers $\atomrawint{\rawint}{\pre}{\sign}$ are integer constants
         with any of the various bit precisions $\pre$, and signedness $\sign$.
   \item The floating-point numbers $\atomfloat{x}{\fpre}$ are constants
         with any of the various floating-point bit precisions $\fpre$.
   \end{itemize}
\end{itemcase}

\iftechreport

   \begin{itemcase}{Constant constructors}
      Constant atoms are an optimization defined for allocating zero-arity
      elements of unions.  The atom
      $\atomconst{\tyunion{\tyvar}{\cvec{t\subi}{\polybase}{\polybound}}{\mkset{i}}}{\tyvar}{i}$
      has union type
      $\tyunion{\tyvar}{\cvec{t\subi}{\polybase}{\polybound}}{\mkset{i}}$ if the
      $i^\ms{th}$ case of the union defined by $\tyvar$ has zero arity.
   \end{itemcase}

   \begin{itemcase}{Frame record values}
      The labels $\atomlabel{\tyvar}{\framelabel{f}}{\framelabel{sf}}{\rawint}$
      represent offsets into a frame record.  The type variable $\tyvar$ is the
      name of the frame type definition, the label $\framelabel{f}$ is the field
      name, the label $\framelabel{sf}$ is the sub-field name, and $\rawint$ is an
      additional offset into the field.

      Similarly, the atom
      $\atomsizeof{\cvec{\tyvar\subi}{\varbase}{\varbound}}{\rawint}$ represents the
      combined size of a list of frames $\cvec{\tyvar\subi}{\varbase}{\varbound}$
      plus a constant $\rawint$.
   \end{itemcase}

\fi

\begin{itemcase}{Variables}
   The variables $v$ represent values defined in the program environment,
   described in
   \iftechreport
      Chapter~\ref{section:judgments}.
   \else
      Section~\ref{section:judgments}.
   \fi
   Variables are immutable: the \fir{} does not include
   a variable assignment operation.
\end{itemcase}

\begin{itemcase}{Polymorphic operations}\iftechreport\ \fi
   \begin{itemize}
   \setlength\itemsep{0in}

   \item The $\atomtyapply{t}{v}{\cvec{\typename\subi}{\polybase}{\polybound}}$
         atom is a type application of a polymorphic value $v$ to type arguments
         $\cvec{t\subi}{\polybase}{\polybound}$.  For the application to be
         well-formed, the variable $v$ must have universal type
         $\tyall{\cvec{\alpha\subi}{\polybase}{\polybound}}{u}$; the atom has type
         \iftechreport
            $t = u[\cvec{t\subi/\alpha\subi}{\polybase}{\polybound}]$.
         \else
            $u[\cvec{t\subi/\alpha\subi}{\polybase}{\polybound}]$.
         \fi

   \item The $\atomtypack{t}{v}{\cvec{\typename\subi}{\polybase}{\polybound}}$
         atom performs type abstraction.  It has type
         $t=\tyexists{\cvec{\alpha\subi}{\polybase}{\polybound}}{u}$
         when $v$ has type
         $u[\cvec{t\subi/\alpha\subi}{\polybase}{\polybound}]$.

   \item The $\atomtyunpack{v}$ atom is the elimination form for type
         % EMRE: Hack to get both the tech report and the POPL paper not to have
         %       overflowing text.
         \iftechreport
            abstraction packages.
         \else
            abstraction.
         \fi
         If $v$ has existential type
         $\tyexists{\cvec{\alpha\subi}{\polybasezero}{\polyboundzero}}{u}$,
         the atom has type
         $u[\cvec{\typroject{v}{\nosubi}/\alpha\subi}{\polybasezero}{(\polyboundzero)}]$.
         The types $\typroject{v}{i}$ represent the type parameter
         $t_i$ in the original pack operation.

   \end{itemize}
\end{itemcase}

\begin{itemcase}{Arithmetic}
   There are two forms for arithmetic: unary operations
   $\atomunop{\unop}{a}$, and binary operations
   $\atombinop{\binop}{a_1}{a_2}$.
   \iftechreport
      The operator tables are listed in
      Figures~\ref{figure:fir-unops}--\ref{figure:fir-binops}.
   \else
      The operators, shown in Figure~\ref{figure:fir-ops},
      include the normal operations for arithmetic.
   \fi
\end{itemcase}

\makefigure{figure:fir-atoms}{FIR atoms}{%
$$
\begin{array}{\iftechreport rclll \else rcll@{}l \fi}
& & \hbox{Definition} & \hbox{Description} & \tronly{\hbox{FIR Expression}}\\
\hline

% DROPPED:
%     AtomNil - jyh is ``unsure'' about it.
%     AtomFun - exists only to make life easier in MetaPRL

a & ::= & \atomenum{i_\ms{bound}}{i_\ms{value}}
        & \hbox{Enumerated value}
        & \tronly{\mt{AtomEnum}\ (i_\ms{bound}, i_\ms{value})}\\
  &  |  & \atomint{i}
        & \hbox{Boxed integer constants}
        & \tronly{\mt{AtomInt}\ i}\\
  &  |  & \atomrawint{\rawint}{\pre}{\sign}
        & \hbox{Raw integer constants}
        & \tronly{\mt{AtomRawInt}\ \rawint}\\
  &  |  & \atomfloat{x}{\fpre}
        & \hbox{Floating-point constants}
        & \tronly{\mt{AtomFloat}\ x}\\
\iftechreport
  &  |  & \atomlabel{\tyvar}{\framelabel{f}}{\framelabel{sf}}{\rawint}
        & \hbox{Offset into a frame record}
        & \tronly{\mt{AtomLabel}\ (\tyvar, \framelabel{f}, \framelabel{sf}, \rawint)} \\
  &  |  & \atomsizeof{\cvec{\tyvar\subi}{\varbase}{\varbound}}{\rawint}
        & \hbox{Size of frames, plus $r$}
        & \tronly{\mt{AtomSizeof}\ ([\semivec{\tyvar\subi}{\varbase}{\varbound}], \rawint)}\\
  &  |  & \atomconst{t}{\tyvar}{i}
        & \hbox{Constant union constructor}
        & \tronly{\mt{AtomConst}\ (t, \tyvar, i)}\\
\fi
  &  |  & \atomvar{v}
        & \hbox{Variables}
        & \tronly{\mt{AtomVar}\ v}\\
  &  |  & \atomtyapply{t}{a}{\cvec{\typename\subi}{\polybase}{\polybound}}
        & \hbox{Type application}
        & \tronly{\mt{AtomTyApply}\ (a, t, [\semivec{\typename\subi}{\polybase}{\polybound}])}\\
  &  |  & \atomtypack{t}{v}{\cvec{\typename\subi}{\polybase}{\polybound}}
        & \hbox{Existential packing}
        & \tronly{\mt{AtomTyPack}\ (v, t, [\semivec{\typename\subi}{\polybase}{\polybound}])}\\
  &  |  & \atomtyunpack{v}
        & \hbox{Existential unpacking}
        & \tronly{\mt{AtomTyUnpack}\ v}\\
  &  |  & \atomunop{\unop}{a}
        & \hbox{Unary operation}
        & \tronly{\mt{AtomUnop}\ (\unop, a)}\\
  &  |  & \atombinop{\binop}{a_1}{a_2}
        & \hbox{Binary operation}
        & \tronly{\mt{AtomBinop}\ (\binop, a_1, a_2)}
\end{array}
$$}

%
% Unary and binary operators are not included in the paper
%
\iftechreport

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Unary operators
%
\sectionD{Unary operators}
\label{section:fir-unop}

The unary operators are shown in Figure~\ref{figure:fir-unops}.  We
use the following meta-notation in the table.  For an operator
$\unop$, the term $\unoptypearg{\unop}$ specifies the type of the
argument of the operator (in the \emph{Arg} column), and the term
$\unoptyperes{\unop}$ specifies the type of the result (in the
\emph{Result} column).

Most of the operators are for performing arithmetic with various bit
precisions.  The exception to this is $\ucoerceop{t_d}{t_s}$,
which performs a runtime coercion.  While we do not list the coercions
explicitly here, the coercions are mainly between numerical arguments.
Some coercions require runtime checks to ensure safety.

\makefigure{figure:fir-unops}{FIR unary operators}{%
$$
\begin{array}{lllll}
\hbox{Operator} & \hbox{Result} & \hbox{Arg} & \hbox{Description} & \hbox{FIR Entity}\\
\hline

\uminusop{\tyint}
   & \tyint
   & \tyint
   & \hbox{Unary negation}
   & \mt{UMinusIntOp}

\\

\uminusop{\tyrawint{\pre}{\sign}}
   & \tyrawint{\pre}{\sign}
   & \tyrawint{\pre}{\sign}
   &
   & \mt{UMinusRawIntOp}\ (\pre, \sign)

\\

\uminusop{\tyfloat{\fpre}}
   & \tyfloat{\fpre}
   & \tyfloat{\fpre}
   &
   & \mt{UMinusFloatOp}\ \fpre

\\

\unotop{\tyint}
   & \tyint
   & \tyint
   & \hbox{Bitwise negation}
   & \mt{NotIntOp}

\\

\unotop{\tyrawint{\pre}{\sign}}
   & \tyrawint{\pre}{\sign}
   & \tyrawint{\pre}{\sign}
   &
   & \mt{NotRawIntOp}\ (\pre, \sign)

\\

\ubitfieldop{\pre}{\sign}{i}{j}
   & \tyrawint{\pre}{\sign}
   & \tyrawint{32}{\sign}
   & \hbox{Extract bitfield at offset $i$ (size $j$)}
   & \mt{RawBitFieldOp}\ (\pre, \sign, i, j)

\\

\uabsop{\fpre}
   & \tyfloat{\fpre}
   & \tyfloat{\fpre}
   & \hbox{Absolute value}
   & \mt{AbsFloatOp}\ \fpre

\\

\usinop{\fpre}
   & \tyfloat{\fpre}
   & \tyfloat{\fpre}
   & \hbox{Sine}
   & \mt{SinOp}\ \fpre

\\

\ucosop{\fpre}
   & \tyfloat{\fpre}
   & \tyfloat{\fpre}
   & \hbox{Cosine}
   & \mt{CosOp}\ \fpre

\\

\usqrtop{\fpre}
   & \tyfloat{\fpre}
   & \tyfloat{\fpre}
   & \hbox{Square root}
   & \mt{SqrtOp}\ \fpre

\\

% INCONSISTENCY:
%     Various coercion operators are not explicitly listed here

\ucoerceop{t_d}{t_s}
   & t_d
   & t_s
   & \hbox{Coerce between types (safely)}
   & \ldots

\\

% DROPPED:
%     PointerOfBlockOp omitted -- no TyPointer here.

\end{array}
$$
}

%
% Still under the ``true'' clause of \iftechreport...
%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Binary operators
%

\sectionD{Binary operators}
\label{section:fir-binop}

There are two classes of binary operators: comparisons, and
arithmetic, shown in Figures \ref{figure:fir-binops-compare} and
\ref{figure:fir-binops}, respectively.
We use the following meta-notation in
the tables.  For an operator $\binop$, the term
$\binoptypearg{i}{\binop}$ specifies the type of argument $i$ of the
operator.  The index $i$ is either $1$ or $2$, and the type is listed
in the \emph{Arg} $i$ column.  The term $\binoptyperes{\binop}$
specifies the type of the result, listed in the \emph{Result} column.

The comparison operators are shown in
Figure~\ref{figure:fir-binops-compare}.  In most cases, the result of
a comparison has the type $\tybool$, which is used to represent
Boolean values.  The $\cmpop{p}$ operators are an exception.
The result of a comparison $i \mathrel{\cmpop{p}} j$ is negative if $i
< j$ (using the specified precision and signedness), positive if $i > j$, and
zero if $i = j$.

There are also two non-arithmetic comparisons.  The operator
$\eqop{t}$ compares two values of type $t$.  The type $t$ is
arbitrary, and we do not specify the semantics precisely.  For any
comparison $a_1 \mathrel{\eqop{t}} a_2$, the result is not true if
$a_1 \neq a_2$.  The comparison $a_1 \mathrel{\neqop{t}} a_2$ is the
same as $\neg (a_1 \mathrel{\eqop{t}} a_2)$.

The operators for binary arithmetic and bitwise operations are shown in
Figure~\ref{figure:fir-binops}.

\makefigure{figure:fir-binops-compare}{FIR binary comparison operators}{%
$$
\begin{array}{llllll}
\hbox{Operator} & \hbox{Result} & \hbox{Arg $1$} & \hbox{Arg $2$} & \hbox{Description} & \hbox{FIR Entity}\\
\hline

\eqop{\tyint}
   & \tyenum{2}
   & \tyint
   & \tyint
   & \hbox{Test for equality}
   & \mt{EqIntOp}

\\

\eqop{\tyrawint{\pre}{\sign}}
   & \tyenum{2}
   & \tyrawint{\pre}{\sign}
   & \tyrawint{\pre}{\sign}
   &
   & \mt{EqRawIntOp}\ (\pre, \sign)

\\

\eqop{\tyfloat{\fpre}}
   & \tyenum{2}
   & \tyfloat{\fpre}
   & \tyfloat{\fpre}
   &
   & \mt{EqFloatOp}\ \fpre

\\

\neqop{\tyint}
   & \tyenum{2}
   & \tyint
   & \tyint
   & \hbox{Test for inequality}
   & \mt{NeqIntOp}

\\

\neqop{\tyrawint{\pre}{\sign}}
   & \tyenum{2}
   & \tyrawint{\pre}{\sign}
   & \tyrawint{\pre}{\sign}
   &
   & \mt{NeqRawIntOp}\ (\pre, \sign)

\\

\neqop{\tyfloat{\fpre}}
   & \tyenum{2}
   & \tyfloat{\fpre}
   & \tyfloat{\fpre}
   &
   & \mt{NeqFloatOp}\ \fpre

\\

\ltop{\tyint}
   & \tyenum{2}
   & \tyint
   & \tyint
   & \hbox{Test for less than}
   & \mt{LtIntOp}

\\

\ltop{\tyrawint{\pre}{\sign}}
   & \tyenum{2}
   & \tyrawint{\pre}{\sign}
   & \tyrawint{\pre}{\sign}
   &
   & \mt{LtRawIntOp}\ (\pre, \sign)

\\

\ltop{\tyfloat{\fpre}}
   & \tyenum{2}
   & \tyfloat{\fpre}
   & \tyfloat{\fpre}
   &
   & \mt{LtFloatOp}\ \fpre

\\

\leop{\tyint}
   & \tyenum{2}
   & \tyint
   & \tyint
   & \hbox{Test for less than or equal}
   & \mt{LeIntOp}

\\

\leop{\tyrawint{\pre}{\sign}}
   & \tyenum{2}
   & \tyrawint{\pre}{\sign}
   & \tyrawint{\pre}{\sign}
   &
   & \mt{LeRawIntOp}\ (\pre, \sign)

\\

\leop{\tyfloat{\fpre}}
   & \tyenum{2}
   & \tyfloat{\fpre}
   & \tyfloat{\fpre}
   &
   & \mt{LeFloatOp}\ \fpre

\\

\gtop{\tyint}
   & \tyenum{2}
   & \tyint
   & \tyint
   & \hbox{Test for greater than}
   & \mt{GtIntOp}

\\

\gtop{\tyrawint{\pre}{\sign}}
   & \tyenum{2}
   & \tyrawint{\pre}{\sign}
   & \tyrawint{\pre}{\sign}
   &
   & \mt{GtRawIntOp}\ (\pre, \sign)

\\

\gtop{\tyfloat{\fpre}}
   & \tyenum{2}
   & \tyfloat{\fpre}
   & \tyfloat{\fpre}
   &
   & \mt{GtFloatOp}\ \fpre

\\

\geop{\tyint}
   & \tyenum{2}
   & \tyint
   & \tyint
   & \hbox{Test for greater than or equal}
   & \mt{GeIntOp}

\\

\geop{\tyrawint{\pre}{\sign}}
   & \tyenum{2}
   & \tyrawint{\pre}{\sign}
   & \tyrawint{\pre}{\sign}
   &
   & \mt{GeRawIntOp}\ (\pre, \sign)

\\

\geop{\tyfloat{\fpre}}
   & \tyenum{2}
   & \tyfloat{\fpre}
   & \tyfloat{\fpre}
   &
   & \mt{GeFloatOp}\ \fpre

\\

\cmpop{\tyint}
   & \tyint
   & \tyint
   & \tyint
   & \hbox{ML-style comparison}
   & \mt{CmpIntOp}

\\

\cmpop{\tyrawint{\pre}{\sign}}
   & \tyint
   & \tyrawint{\pre}{\sign}
   & \tyrawint{\pre}{\sign}
   &
   & \mt{CmpRawIntOp}\ (\pre, \sign)

\\

\cmpop{\tyfloat{\fpre}}
   & \tyint
   & \tyfloat{\fpre}
   & \tyfloat{\fpre}
   &
   & \mt{CmpFloatOp}\ \fpre

\\

\eqop{t}
   & \tyenum{2}
   & t
   & t
   & \hbox{Test for pointer equality}
   & \mt{EqEqOp}\ t

\\

\neqop{t}
   & \tyenum{2}
   & t
   & t
   & \hbox{Test for pointer inequality}
   & \mt{NeqEqOp}\ t

\end{array}
$$
}

\makefigure{figure:fir-binops}{FIR binary operators}{
$$
\begin{array}{llllll}
\hbox{Operator} & \hbox{Result} & \hbox{Arg $1$} & \hbox{Arg $2$} & \hbox{Description} & \hbox{FIR Entity}\\
\hline

\plusop{\tyint}
   & \tyint
   & \tyint
   & \tyint
   & \hbox{Addition}
   & \mt{PlusIntOp}

\\

\plusop{\tyrawint{\pre}{\sign}}
   & \tyrawint{\pre}{\sign}
   & \tyrawint{\pre}{\sign}
   & \tyrawint{\pre}{\sign}
   &
   & \mt{PlusRawIntOp}\ (\pre, \sign)

\\

\plusop{\tyfloat{\fpre}}
   & \tyfloat{\fpre}
   & \tyfloat{\fpre}
   & \tyfloat{\fpre}
   &
   & \mt{PlusFloatOp}\ \fpre

\\

\minusop{\tyint}
   & \tyint
   & \tyint
   & \tyint
   & \hbox{Subtraction}
   & \mt{MinusIntOp}

\\

\minusop{\tyrawint{\pre}{\sign}}
   & \tyrawint{\pre}{\sign}
   & \tyrawint{\pre}{\sign}
   & \tyrawint{\pre}{\sign}
   &
   & \mt{MinusRawIntOp}\ (\pre, \sign)

\\

\minusop{\tyfloat{\fpre}}
   & \tyfloat{\fpre}
   & \tyfloat{\fpre}
   & \tyfloat{\fpre}
   &
   & \mt{MinusFloatOp}\ \fpre

\\

\mulop{\tyint}
   & \tyint
   & \tyint
   & \tyint
   & \hbox{Multiplication}
   & \mt{MulIntOp}

\\

\mulop{\tyrawint{\pre}{\sign}}
   & \tyrawint{\pre}{\sign}
   & \tyrawint{\pre}{\sign}
   & \tyrawint{\pre}{\sign}
   &
   & \mt{MulRawIntOp}\ (\pre, \sign)

\\

\mulop{\tyfloat{\fpre}}
   & \tyfloat{\fpre}
   & \tyfloat{\fpre}
   & \tyfloat{\fpre}
   &
   & \mt{MulFloatOp}\ \fpre

\\

\divop{\tyint}
   & \tyint
   & \tyint
   & \tyint
   & \hbox{Division}
   & \mt{DivIntOp}

\\

\divop{\tyrawint{\pre}{\sign}}
   & \tyrawint{\pre}{\sign}
   & \tyrawint{\pre}{\sign}
   & \tyrawint{\pre}{\sign}
   &
   & \mt{DivRawIntOp}\ (\pre, \sign)

\\

\divop{\tyfloat{\fpre}}
   & \tyfloat{\fpre}
   & \tyfloat{\fpre}
   & \tyfloat{\fpre}
   &
   & \mt{DivFloatOp}\ \fpre

\\

\remop{\tyint}
   & \tyint
   & \tyint
   & \tyint
   & \hbox{Remainder}
   & \mt{RemIntOp}

\\

\remop{\tyrawint{\pre}{\sign}}
   & \tyrawint{\pre}{\sign}
   & \tyrawint{\pre}{\sign}
   & \tyrawint{\pre}{\sign}
   &
   & \mt{RemRawIntOp}\ (\pre, \sign)

\\

\remop{\tyfloat{\fpre}}
   & \tyfloat{\fpre}
   & \tyfloat{\fpre}
   & \tyfloat{\fpre}
   &
   & \mt{RemFloatOp}\ \fpre

\\

\lslop
   & \tyint
   & \tyint
   & \tyint
   & \hbox{Logical shift left}
   & \mt{LslIntOp}

\\

\lsrop
   & \tyint
   & \tyint
   & \tyint
   & \hbox{Logical shift right}
   & \mt{LsrIntOp}

\\

\asrop
   & \tyint
   & \tyint
   & \tyint
   & \hbox{Arithmetic shift right}
   & \mt{AsrIntOp}

\\

\slop{\tyrawint{\pre}{\sign}}
   & \tyrawint{\pre}{\sign}
   & \tyrawint{\pre}{\sign}
   & \tyrawint{\pre}{\sign}
   & \hbox{Shift left}
   & \mt{SlRawIntOp}\ (\pre, \sign)

\\

\srop{\tyrawint{\pre}{\sign}}
   & \tyrawint{\pre}{\sign}
   & \tyrawint{\pre}{\sign}
   & \tyrawint{\pre}{\sign}
   & \hbox{Shift right}
   & \mt{SrRawIntOp}\ (\pre, \sign)

\\

\andop{\tyint}
   & \tyint
   & \tyint
   & \tyint
   & \hbox{Logical and}
   & \mt{AndIntOp}

\\

\andop{\tyrawint{\pre}{\sign}}
   & \tyrawint{\pre}{\sign}
   & \tyrawint{\pre}{\sign}
   & \tyrawint{\pre}{\sign}
   &
   & \mt{AndRawIntOp}\ (\pre, \sign)

\\

\andop{\tyenum{i}}
   & \tyenum{i}
   & \tyenum{i}
   & \tyenum{i}
   &
   & \mt{AndEnumOp}\ i

\\

\orop{\tyint}
   & \tyint
   & \tyint
   & \tyint
   & \hbox{Logical or}
   & \mt{OrIntOp}

\\

\orop{\tyrawint{\pre}{\sign}}
   & \tyrawint{\pre}{\sign}
   & \tyrawint{\pre}{\sign}
   & \tyrawint{\pre}{\sign}
   &
   & \mt{OrRawIntOp}\ (\pre, \sign)

\\

\orop{\tyenum{i}}
   & \tyenum{i}
   & \tyenum{i}
   & \tyenum{i}
   &
   & \mt{OrEnumOp}\ i

\\

\xorop{\tyint}
   & \tyint
   & \tyint
   & \tyint
   & \hbox{Logical xor}
   & \mt{XorIntOp}

\\

\xorop{\tyrawint{\pre}{\sign}}
   & \tyrawint{\pre}{\sign}
   & \tyrawint{\pre}{\sign}
   & \tyrawint{\pre}{\sign}
   &
   & \mt{XorRawIntOp}\ (\pre, \sign)

\\

\xorop{\tyenum{i}}
   & \tyenum{i}
   & \tyenum{i}
   & \tyenum{i}
   &
   & \mt{XorEnumOp}\ i

\\

\maxop{\tyint}
   & \tyint
   & \tyint
   & \tyint
   & \hbox{Maximum of two values}
   & \mt{MaxIntOp}

\\

\maxop{\tyrawint{\pre}{\sign}}
   & \tyrawint{\pre}{\sign}
   & \tyrawint{\pre}{\sign}
   & \tyrawint{\pre}{\sign}
   &
   & \mt{MaxRawIntOp}\ (\pre, \sign)

\\

\maxop{\tyfloat{\fpre}}
   & \tyfloat{\fpre}
   & \tyfloat{\fpre}
   & \tyfloat{\fpre}
   &
   & \mt{MaxFloatOp}\ \fpre

\\

\minop{\tyint}
   & \tyint
   & \tyint
   & \tyint
   & \hbox{Minimum of two values}
   & \mt{MinIntOp}

\\

\minop{\tyrawint{\pre}{\sign}}
   & \tyrawint{\pre}{\sign}
   & \tyrawint{\pre}{\sign}
   & \tyrawint{\pre}{\sign}
   &
   & \mt{MinRawIntOp}\ (\pre, \sign)

\\

\minop{\tyfloat{\fpre}}
   & \tyfloat{\fpre}
   & \tyfloat{\fpre}
   & \tyfloat{\fpre}
   &
   & \mt{MinFloatOp}\ \fpre

\\

\atanop{\fpre}
   & \tyfloat{\fpre}
   & \tyfloat{\fpre}
   & \tyfloat{\fpre}
   & \hbox{Arc tangent}
   & \mt{Atan2Op}\ \fpre

\\

\setbitfieldop{\pre}{\sign}{i}{j}
   & \tyrawint{\pre}{\sign}
   & \tyrawint{32}{\sign}
   & \tyrawint{\pre}{\sign}
   & \hbox{Set bit field at offset $i$}
%  & \mt{RawSetBitFieldOp}\ (\pre, \sign, i, j)
   & \mt{RawSetBitFieldOp}\ (\ldots)

\\

% DROPPED:
%     PlusPointerOp omitted -- no TyPointer support.

\end{array}
$$
}

%
% Unary and binary operators are not included in the paper
%
\fi

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Expressions
%
\sectionC{Expressions}

The expressions $e$ are shown in Figure~\ref{figure:fir-exp}.
Both scope and control-flow are explicit.

\begin{itemcase}{LetAtom}
   The $\letatom{v}{t}{a}{e}$ expression forms a new scope, where the
   variable $v$ is bound to the value of the atom expression $a$ in the
   expression $e$.  For the expression to be well-formed, the atom must
   have type $t$, and the expression $e$ must be well-formed for an
   arbitrary value $v$ of type $t$.
\end{itemcase}

\begin{itemcase}{LetExt}
   The external-call expression
   $\letext{v}{t_v}{s}{t_s}{\cvec{\atomname\subi}{\varbase}{\varbound}}{e}$ is
   used to provide access to the runtime and operating system.  The string ``s''
   represents the name of a runtime function to be called with arguments
   $\cvec{a\subi}{\varbase}{\varbound}$.  For the expression to be well-formed,
   the runtime function ``s'' must have type
   $t_s = \tyfun{\argvec{u\subi}{\varbase}{\varbound}}{t_v}$,
   each atom $a_i$ must have
   type $u_i$, and $e$ must be well-formed given a value $v$ with type $t_v$.
\end{itemcase}

\begin{itemcase}{TailCall}
   The tail-call $\tailcall{a}{\cvec{\atomname\subi}{\varbase}{\varbound}}$
   represents a function call to the function $a$, with arguments
   $\cvec{a\subi}{\varbase}{\varbound}$.  For the tail-call to be well-formed,
   the function $a$ must have some type
   $\tyfun{\argvec{u\subi}{\varbase}{\varbound}}{\tyvoid}$, and each argument
   $a_i$ must have type $u_i$.

   The return type of the function is the empty type $\tyvoid$.  There is no
   syntactic mechanism for using the return value of a function, and functions
   never return.
\end{itemcase}

\begin{itemcase}{SpecialCall}
   The special-call $\specialcall{\tailop}$ represents a call
   for process migration, or one of the atomic transaction operations.
   The $\tailop$ operations are shown in Figure~\ref{figure:fir-ops}.
   % No need for forward references in the POPL paper.
   \tronly{The special-call operations are described in detail in
   Chapter~\ref{section:backend}.  The typing rules are defined in
   Section~\ref{section:special-type-rules}, and the operational
   semantics are defined in Section~\ref{section:special-op-semantics}.}

   % Simplified descriptions for the POPL paper, longer descriptions
   % for the tech report.

   \iftechreport

      \begin{itemize}
         \item The operator $\tailsysmigrate{i}{a_p}{a_o}{a_\xfun}{a_1,
            \ldots, a_n}$ defines a process migration.  The argument $(a_p,
            a_o)$ specifies the destination (for example, the name of a
            migration server), and the argument $a_\xfun(a_1,
            \ldots, a_n)$ specifies a function to be called once the process
            migrates, along with its arguments.

         \item The operator $\tailatomic{a_\xfun}{a_\xconst}{a_1, \ldots,
            a_n}$ specifies entry into an atomic transaction.  This operation
            effectively takes a process checkpoint, which can be restored if the
            transaction is aborted.  Once the transaction is entered, the
            function $a_\xfun$ is called with arguments $a_\xconst,
            \cvec{a\subi}{1}{n}$.

         \item The operator $\tailatomicrollback{a_\xlevel}{a_\xconst}$
            is used to abort a transaction.  The atom $a_\xlevel$ is the name
            of the transaction to be aborted (the transaction checkpoints are
            saved in a list).  Transactions are restarted on failure, and the
            atom $a_\xconst$ is a new argument to be passed to the
            transaction entry point when the transaction is restarted.

            For example, if the transaction was entered with the operator
            $\tailatomic{a_\xfun}{a_\xconst}{a_1, \ldots, a_n}$, and the
            transaction is aborted with the
            $\tailatomicrollback{a_\xlevel'}{a_\xconst'}$, the transaction
            is \emph{resumed} with the tail-call $a_\xfun(a_\xconst', a_1,
            \ldots, a_n)$.

         \item The operator $\tailatomiccommit{a_\xlevel}{a_\xfun}{a_1,
            \ldots, a_n}$ commits the transaction identified by $a_\xlevel$.
            The transaction checkpoint identified by $a_\xlevel$ is discarded,
            and the function $a_\xfun$ is called with arguments
            $\cvec{a\subi}{1}{n}$.
      \end{itemize}

   \else

      The operator
      $\tailsysmigrate{i}{a_p}{a_o}{a_\xfun}{\cvec{\atomname\subi}{\varbase}{\varbound}}$
      defines a process migration.  The operator
      $\tailatomic{a_\xfun}{a_\xconst}{\cvec{\atomname\subi}{\varbase}{\varbound}}$
      specifies entry into an atomic transaction.
      The operator $\tailatomicrollback{a_\xlevel}{a_\xconst}$
      is used to abort a transaction.  The operator
      $\tailatomiccommit{a_\xlevel}{a_\xfun}{\cvec{\atomname\subi}{\varbase}{\varbound}}$
      commits the transaction identified by $a_\xlevel$.

   \fi
\end{itemcase}

\begin{itemcase}{Match}
   The match statement $\matchstmt{a}{\lvec{\matchcase{s\subi}{e\subi}}{\varbase}{\varbound}}$
   is a pattern match of an integer against multiple sets.
   Each match case $\matchcase{s_i}{e_i}$ specifies an integer (or raw integer) set $s_i$
   and an expression $e_i$ to be evaluated if $a \in s_i$.
   Evaluation is ordered and total.  Evaluation chooses the \emph{first} match that
   succeeds, and the match statement is well-formed only if there is a match case for
   any possible value of $a$.
\end{itemcase}

\begin{itemcase}{Data aggregates}
   The aggregate data areas include tuples, arrays, elements in a union type,
   \iftechreport
      raw data, and frames.
   \else
      and raw data.
   \fi
   The $\letalloc{v}{\allocop}{e}$ expression allocates a data aggregate, using
   one of the \emph{alloc} forms shown in Figure~\ref{figure:fir-ops}.

   Values are projected from an aggregate data area using the
   $\letsubscript{v}{t}{a_1}{a_2}{e}$ expression. For the expression to be
   well-formed, $a_1$ must be an aggregate, and $a_2$ must be a valid index
   into the aggregate.  All fields in aggregates are mutable.  The
   $\setsubscript{a_1}{a_2}{t}{a_3}{e}$ expression assigns value
   $a_3$ to field $a_2$ in aggregate $a_1$.
\end{itemcase}

\begin{itemcase}{Global values}
   The global values are a set of global mutable values (normally used to
   represent global variables in languages like C).  Global values are not
   directly accessible as atoms.  The value in global location $\xlabel$ can be
   retrieved with the expression $\letglobal{v}{t}{\xlabel}{e}$, and assigned
   with the expression $\setglobal{\xlabel}{t}{a}{e}$.
\end{itemcase}

\makefigure{figure:fir-exp}{FIR expressions}{%
$$
\begin{array}{\iftechreport rclll \else rcll@{}l \fi}
& & \hbox{Definition} & \hbox{Description} & \tronly{\hbox{FIR Expression}}\\
\hline

e & ::= & \letatom{v}{t}{a}{e}
        & \hbox{Primitive operations}
        & \tronly{\mt{LetAtom}\ (v, t, a, e)}\\
\iftechreport
  &  |  & \letext{v}{t_v}{s}{t_s}{\cvec{a\subi}{\varbase}{\varbound}}{e}
        & \hbox{Calls to the runtime}
        & \tronly{\mt{LetExt}\ (v, t_v, s, t_s, [\semivec{\atomname\subi}{\varbase}{\varbound}], e))}\\
\else
  &  |  & \multicolumn{2}{l}{\letexthead{v}{t_v}{s}{t_s}{\cvec{a\subi}{\varbase}{\varbound}}}\\
  &     & \letexttail{e}
        & \hbox{Calls to the runtime}
        & \tronly{\mt{LetExt}\ (v, t_v, s, t_s, [\semivec{\atomname\subi}{\varbase}{\varbound}], e))}\\
\fi
  &  |  & \tailcall{a}{\cvec{\atomname\subi}{\varbase}{\varbound}}
        & \hbox{Tail-call}
        & \tronly{\mt{TailCall}\ (\debuglabel, a, [\semivec{\atomname\subi}{\varbase}{\varbound}]))}\\
  &  |  & \specialcall{\tailop}
        & \hbox{Special tail-call}
        & \tronly{\mt{SpecialCall}\ (\debuglabel, \tailop))}\\
  &  |  & \matchstmt{a}{\lvec{\matchcase{s\subi}{e\subi}}{\varbase}{\varbound}}
        & \hbox{Case analysis}
        & \tronly{\mt{Match}\ (a, [\ \lvec{(\hint, s\subi, e\subi)}{\varbase}{\varbound}\ ]) }\\
  &  |  & \letalloc{v}{\allocop}{e}
        & \hbox{Allocation}
        & \tronly{\mt{LetAlloc}\ (v, \allocop, e))}\\
  &  |  & \letsubscript{v}{t}{a_1}{a_2}{e}
        & \hbox{Load from heap}
        & \tronly{\mt{LetSubscript}\ (\subop, v, t, a_1, a_2, e))}\\
  &  |  & \setsubscript{a_1}{a_2}{t}{a_3}{e}
        & \hbox{Store into heap}
        & \tronly{\mt{SetSubscript}\ (\subop, \debuglabel, a_1, a_2, t, a_3, e))}\\
  &  |  & \letglobal{v}{t}{\xlabel}{e}
        & \hbox{Load from global}
        & \tronly{\mt{LetGlobal}\ (\subop, v, t, \xlabel, e))}\\
  &  |  & \setglobal{\xlabel}{t}{a}{e}
        & \hbox{Store into global}
        & \tronly{\mt{SetGlobal}\ (\subop, \debuglabel, \xlabel, t, a, e))}

% DROPPED:
%     TypeCase dropped -- object system not supported here.
%     Memcpy dropped -- redundant instruction
%     Call ignored -- no semantic content
%     Assert ignored -- FIR safety does not work, currently
%     Debug ignored -- no semantic content

\end{array}
$$}

%
% Operators
%
\makefigure{figure:fir-ops}{FIR operators}{%
$$
\begin{array}{\iftechreport rclll \else rcll@{}l \fi}
& & \hbox{Definition}
  & \iftechreport \hbox{Description} \else \hbox{Desc} \fi
  & \tronly{\hbox{FIR Expression}}\\
\hline

\unop    & ::= & - \vbar \ ! \vbar \cdots
               & \iftechreport \hbox{Unary operations} \else \hbox{Arith} \fi
               & \tronly{\mt{Fir.unop}}\\
\binop   & ::= & + \vbar - \vbar * \vbar / \vbar \cdots
               & \iftechreport \hbox{Binary operations} \else \hbox{Arith} \fi
               & \tronly{\mt{Fir.binop}}\\

\\

\allocop & ::= & \alloctuple{\tupleclass}{t}{\cvec{\atomname\subi}{\varbase}{\varbound}}
               & \iftechreport \hbox{Tuple allocation} \else \hbox{Tuple} \fi
               & \tronly{\mt{AllocTuple}\ (\ldots)}\\
         &  |  & \allocunion{t}{\tyvar}{\cvec{\atomname\subi}{\varbase}{\varbound}}{i}
               & \iftechreport \hbox{Union allocation} \else \hbox{Union} \fi
               & \tronly{\mt{AllocUnion}\ (\ldots)}\\
         &  |  & \allocarray{t}{a_\ms{size}}{a_\ms{init}}
               & \iftechreport \hbox{Array allocation} \else \hbox{Array} \fi
               & \tronly{\mt{AllocVArray}\ (\ldots)}\\
         &  |  & \allocmalloc{t}{a}
               & \iftechreport \hbox{Rawdata allocation} \else \hbox{Rawdata} \fi
               & \tronly{\mt{AllocMalloc}\ (\ldots)}\\
\iftechreport
         &  |  & \allocframe{\tyvar}{\cvec{\typename\subi}{\polybase}{\polybound}}
               & \hbox{Allocate a frame}
               & \tronly{\mt{AllocFrame}\ (\ldots)}\\
\fi

\\

\tailop  & ::= & \tailsysmigrate{i}{a_p}{a_o}{a_\xfun}{\cvec{\atomname\subi}{\varbase}{\varbound}}
               & \iftechreport \hbox{System migration} \else \hbox{Migrate} \fi
               & \tronly{\mt{TailSysMigrate}\ (\ldots)}\\
         &  |  & \tailatomic{a_\xfun}{a_\xconst}{\cvec{\atomname\subi}{\varbase}{\varbound}}
               & \iftechreport \hbox{Transaction entry} \else \hbox{Entry} \fi
               & \tronly{\mt{TailAtomic}\ (\ldots)}\\
         &  |  & \tailatomicrollback{a_\xlevel}{a_\xconst}
               & \iftechreport \hbox{Transaction rollback} \else \hbox{Rollback} \fi
               & \tronly{\mt{TailAtomicRollback}\ (\ldots)}\\
         &  |  & \tailatomiccommit{a_\xlevel}{a_\xfun}{\cvec{\atomname\subi}{\varbase}{\varbound}}
               & \iftechreport \hbox{Transaction commit} \else \hbox{Commit} \fi
               & \tronly{\mt{TailAtomicCommit}\ (\ldots)}

\end{array}
$$}

% -*-
% Local Variables:
% Mode: LaTeX
% fill-column: 100
% TeX-master: "paper"
% TeX-command-default: "LaTeX/dvips Interactive"
% End:
% -*-
